# -*- coding: utf-8 -*-
"""
Created on Thu Oct 19 2017
Modified on June 5 2018

@author: johana
"""
# Libraries
from definitions import *
from Features import *
import time

# Global variables
PASOS = 360/7
ABTR =-3*PASOS
TEM = np.genfromtxt('../Data/termal_'+ str(DAY) +'.csv',delimiter=',')
maskTER = np.genfromtxt('../Data/ter_mine.csv',delimiter=',')
SSIZ = 10

#Temporal function
def angle2indt(ang,it,jt):
    indi = 0
    indj = 0        
    if 90 >= ang > 67.5:
        indi = it+1
        indj = jt+1
    elif 67.5 >= ang > 45:
        indi = it
        indj = jt+1
    elif 45 >= ang > 22.5:
        indi = it-1
        indj = jt+1
    elif 22.5 >= ang > 0:
        indi = it
        indj = jt
    elif 0 >= ang > -22.5:
        indi = it-1
        indj = jt
    elif -22.5 >= ang > -45:
        indi = it-1
        indj = jt-1
    elif -45 >= ang > -67.5:
        indi = it
        indj = jt-1
    elif -67.5 >= ang >=-90:
        indi = it+1
        indj = jt-1    
    return int(indi), int(indj)

def TEMsensor(rota,data,it,jt):
    x,y = angle2indt(rota,it,jt)
    mu, sigma = 0, 0.2
    noise = np.random.normal(mu, sigma, 1)
    temp = TEM[y,x] + noise[0]
    data = np.append(data,temp)    
    time.sleep(0.75)
    return data

# Temporal function to indicate mine
def TEMmine(rota,it,jt):
    x,y = angle2indt(rota,it,jt)
    hnm = 0
    if maskTER[y,x] == 1:
        hnm = 1
    return hnm

def TEMfeatures(data):
    # **With Hardware read sensor 
    tmfea = samfeatures(data,data.size)
    return tmfea
    
def runIS(fsinA,fsouA,frulA,fsinB,fsouB,frulB):
    local_dir = os.path.dirname(__file__)
    Net_path0 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-TM0')
    Net_path1 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-TM1')
    Net_path2 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-TM2')
    inputnetI, inputnetG, tam = four.IS_Inputs()
    return a_DMS('TM',Net_path0, Net_path1, Net_path2, inputnetI,inputnetG,tam,16,fsinA,fsouA,frulA,fsinB,fsouB,frulB)

# Agent definition
four= run_agent('TM', base=ModelAgent)
four.phy_address(4,add4)
# Time to predefine the conections among agents
time.sleep(WAITIME)
sam = 0
data = ([])
data1 = ([])
data2 = ([])
data3 = ([])
data4 = ([])
data5 = ([])
data6 = ([])
inicio = time.time()

# Preload logic rules if it is required
if DMS_CUN == 'GFS' or DMS_CUN == 'ALL' or DMS_NBP == 'GFS':
    fsinA,fsouA,frulA,fsinB,fsouB,frulB = a_DMS_FL_Rules('TM')
else:
    fsinA,fsouA,frulA,fsinB,fsouB,frulB = 0.0,0.0,0.0,0.0,0.0,0.0

a = ([])
actt = 0
unct = 0
nbpt = 0
posa = np.zeros(2)

while four.readstop() == 0:
    pos = np.genfromtxt('sim_pos.csv',delimiter=',')
    it=pos[0]/SSIZ
    jt=pos[1]/SSIZ
    
    # Reset array
    if (four.readreset() == 1):
        a = ([])
        
    # Sensor capture
    mu, sigma = 0, RANSER
    noise = np.random.normal(mu, sigma, 1)
    act = four.nbp_read() + noise[0]
    a = four.sensor_read(TEMsensor,act,a,it,jt)
    mine = TEMmine(act,it,jt)

    # Feature extractor
    four.extract_features(TEMfeatures,a)
    
    # Intelligent system 
    uncl,uncg,nbp = runIS(fsinA,fsouA,frulA,fsinB,fsouB,frulB)
    
    if (not(actt == act)) or (not(unct == uncl[0])) or (not(nbtp == nbp[0])) or (not(np.array_equal(pos[0:1],posa))):
        four.info([ANGP*nbp[0],uncl[0],act])
        actt = act
        unct = uncl[0]
        nbtp = nbp[0]
        posa = pos[0:1]
    
    #Save data
    delta = time.time()-inicio
    if DMS_CUN == 'ALL':
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[0],ANGP*nbp[0],act])
        data1 = np.append(data1,tem)
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[1],ANGP*nbp[0],act])
        data2 = np.append(data2,tem)
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[2],ANGP*nbp[0],act])
        data3 = np.append(data3,tem)
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[3],ANGP*nbp[0],act])
        data4 = np.append(data4,tem)
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[4],ANGP*nbp[0],act])
        data5 = np.append(data5,tem)
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[5],ANGP*nbp[0],act])
        data6 = np.append(data6,tem)
    else:
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[0],ANGP*nbp[0],act])
        data = np.append(data,tem)
    sam = sam+1    

if DMS_CUN == 'ALL':
    data1 = np.reshape(data1, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_TM_NEAT_'+DMS_NBP+'.csv',data1,delimiter=',')
    data2 = np.reshape(data2, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_TM_GFS_'+DMS_NBP+'.csv',data2,delimiter=',')
    data3 = np.reshape(data3, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_TM_MEAN_'+DMS_NBP+'.csv',data3,delimiter=',')
    data4 = np.reshape(data4, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_TM_MEDIAN_'+DMS_NBP+'.csv',data4,delimiter=',')
    data5 = np.reshape(data5, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_TM_MAX_'+DMS_NBP+'.csv',data5,delimiter=',')
    data6 = np.reshape(data6, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_TM_VOTE_'+DMS_NBP+'.csv',data6,delimiter=',')
else:
    data = np.reshape(data, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_TM_'+DMS_CUN+'_'+DMS_NBP+'.csv',data,delimiter=',')

four.__del__()