# -*- coding: utf-8 -*-
"""
Created on Wed Oct 18 2017
Modified on June 9 2018

@author: johana
"""
import time
import subprocess
from osbrain import NSProxy
from definitions import *

SAMP = 20
TPSA = 23
TTOT = int(SAMP*TPSA) + 80
START = 0
#TEMPO = 3

def run():
    ns = run_nameserver()
    ns = NSProxy(nsaddr=ns.addr())
    
    #--------------------------Main Processes
    procA1 = subprocess.Popen(["/usr/bin/python3","Agent1.py"])
    procA2 = subprocess.Popen(["/usr/bin/python3","Agent2.py"])
    procA3 = subprocess.Popen(["/usr/bin/python3","Agent3.py"])
    procA4 = subprocess.Popen(["/usr/bin/python3","Agent4.py"])
    procA5 = subprocess.Popen(["/usr/bin/python3","Agent5.py"])
    
    # Wait establish communications and print to verify connections
    time.sleep (5)
    #for alias in ns.agents():
    #    print(alias)
    #--------------------------Extract socket addresses from server
    flag = True
    while flag:
        try:
            one = ns.proxy('SV')
            print('agent one online')
            break
        except:
            print('Try again, agent one')
    while flag:
        try:
            two = ns.proxy('IR')
            print('agent two online')
            break
        except:
            print('Try again, agent two')
    while flag:
        try:
            three = ns.proxy('UV')
            print('agent three online')
            break
        except:
            print('Try again, agent three')
    while flag:
        try:
            four = ns.proxy('TM')
            print('agent four online')
            break
        except:
            print('Try again, agent four')
    while flag:
        try:
            five = ns.proxy('GP')
            print('agent five online')
            break
        except:
            print('Try again, agent five')
    # --------------------------Communication conecctions
    
    # Communication to an Agent with a Visual Spectrum camera
    one.connect(two.addr('main'), handler = 'message_S2')
    one.connect(three.addr('main'), handler = 'message_S3')
    one.connect(four.addr('main'), handler = 'message_S4')
    one.connect(five.addr('main'), handler = 'message_S5')
    one.connect(five.addr('control'), handler = 'message_RS')
    
    # Communication to an Agent with an Infrared camera
    two.connect(one.addr('main'), handler = 'message_S1')
    two.connect(three.addr('main'), handler = 'message_S3')
    two.connect(four.addr('main'), handler = 'message_S4')
    two.connect(five.addr('main'), handler = 'message_S5')
    two.connect(five.addr('control'), handler = 'message_RS')
    
    # Communication to an Agent with an Ultraviolet camera
    three.connect(one.addr('main'), handler = 'message_S1')
    three.connect(two.addr('main'), handler = 'message_S2')
    three.connect(four.addr('main'), handler = 'message_S4')
    three.connect(five.addr('main'), handler = 'message_S5')
    three.connect(five.addr('control'), handler = 'message_RS')
    
    # Communication to an Agent with a termal sensor
    four.connect(one.addr('main'), handler = 'message_S1')
    four.connect(two.addr('main'), handler = 'message_S2')
    four.connect(three.addr('main'), handler = 'message_S3')
    four.connect(five.addr('main'), handler = 'message_S5')
    four.connect(five.addr('control'), handler = 'message_RS')
    
    # Communication to an Agent with a GPR (Ground Penetrating Radar)
    five.connect(one.addr('main'), handler = 'message_S1')
    five.connect(two.addr('main'), handler = 'message_S2')
    five.connect(three.addr('main'), handler = 'message_S3')
    five.connect(four.addr('main'), handler = 'message_S4')
    ##---------------------------------------------------
    
    for i in range(TTOT): 
        time.sleep (1)
        if i%100 == 0:
            print(i)
    
    # Time to wait for stop every process
    time.sleep(6)
    ns.shutdown()
    
inicio = time.time()
test = START
print('Cooperative uncertain with: '+DMS_CUN+' and Next best point: '+DMS_NBP)
all_pos= np.genfromtxt('Positions.csv',delimiter=',')
NTEST = np.shape(all_pos)

#::::::only for test NTEST[0] = TEMPO 
while (test < NTEST[0]):    
    # Store position
    np.savetxt('sim_pos.csv',all_pos[test,:],delimiter=',')
    time.sleep(2)
        
    # Execute main program
    print('Test number: '+ str(all_pos[test,2])+' position in x: '+ str(all_pos[test,0])+ ' in y: '+ str(all_pos[test,1]))
    run()
    point = time.time()    
    delta = point - inicio
    print('Time in test '+str(int(test))+' is '+str(delta)+' s')
    inicio = point
    test = test+1

    # Wait
    time.sleep (5)